import { OnInit } from '@angular/core';
import { MatSort } from '@angular/material/sort';
import { MatPaginator } from '@angular/material/paginator';
import { MatDialog } from '@angular/material/dialog';
import { DataSource } from '@angular/cdk/table';
import { ColumnConfig } from './column-config.model';
import { ColumnFilterService } from './table-cell/cell-types/column-filter.service';
export declare class DynamicTableComponent implements OnInit {
    private readonly columnFilterService;
    private readonly dialog;
    columns: ColumnConfig[];
    dataSource: DataSource<any>;
    pageSize: number;
    pageSizeOptions: number[];
    showFilters: boolean;
    stickyHeader: boolean;
    paginator: MatPaginator;
    onClick: (row: any) => unknown;
    displayedColumns: string[];
    sort: MatSort;
    private internalPaginator;
    private appliedFilters;
    constructor(columnFilterService: ColumnFilterService, dialog: MatDialog);
    ngOnInit(): void;
    isUsingInternalPaginator(): boolean;
    canFilter(column: ColumnConfig): boolean;
    isFiltered(column: ColumnConfig): any;
    getFilterDescription(column: ColumnConfig): any;
    prepareColumnName(name: string, columnNumber: number): string;
    filter(column: ColumnConfig): void;
    clearFilters(): void;
    protected updateDataSource(): void;
    getFilters(): any[];
    getFilter(columnName: string): any;
    setFilter(columnName: string, filter: any): void;
    private getColumnByName;
}
